VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FileAssociation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Manipulates file associations with applications."
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Long, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegSetValueExString Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpValue As String, ByVal cbData As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long

Public Function Create(ByVal sExtension As String, ByVal sAppKeyName As String, ByVal sFileTypeName As String, ByVal sIconPath As String, ByVal intIconIndex As Integer)
Attribute Create.VB_Description = "Creates a file association"
Attribute Create.VB_UserMemId = 0
    Dim reghnd As Long
    Dim tempstr As String
    Call RegCreateKeyEx(&H80000000, sExtension, 0&, vbNullString, 0, &H3F, 0&, reghnd, result)
    Call RegSetValueExString(reghnd, "", 0&, &H1, sAppKeyName, Len(sAppKeyName))
    Call RegCloseKey(reghnd)
    Call RegCreateKeyEx(&H80000000, sAppKeyName, 0&, vbNullString, 0, &H3F, 0&, reghnd, result)
    Call RegSetValueExString(reghnd, "", 0&, &H1, sFileTypeName, Len(sFileTypeName))
    Call RegCloseKey(reghnd)
    Call RegCreateKeyEx(&H80000000, sAppKeyName & "\DefaultIcon", 0&, vbNullString, 0, &H3F, 0&, reghnd, result)
    tempstr = sIconPath & "," & CStr(intIconIndex)
    Call RegSetValueExString(reghnd, "", 0&, &H1, tempstr, Len(tempstr))
    Call RegCloseKey(reghnd)
End Function

Public Sub AddVerb(ByVal sAppKeyName As String, ByVal sVerb As String, sPath As String)
Attribute AddVerb.VB_Description = "Adds an action verb to a file association"
    Call RegCreateKeyEx(&H80000000, sAppKeyName & "\shell\" & sVerb & "\command", 0&, vbNullString, 0, &H3F, 0&, reghnd, result)
    Call RegSetValueExString(reghnd, "", 0&, &H1, sPath, Len(sPath))
    Call RegCloseKey(reghnd)
    Call RegCreateKeyEx(&H80000000, sAppKeyName & "\shell", 0&, vbNullString, 0, &H3F, 0&, reghnd, result)
    Call RegSetValueExString(reghnd, "", 0&, &H1, sVerb, Len(sVerb))
    Call RegCloseKey(reghnd)
End Sub

Public Sub AddVerbNoDefault(ByVal sAppKeyName As String, ByVal sVerb As String, sPath As String)
    Call RegCreateKeyEx(&H80000000, sAppKeyName & "\shell\" & sVerb & "\command", 0&, vbNullString, 0, &H3F, 0&, reghnd, result)
    Call RegSetValueExString(reghnd, "", 0&, &H1, sPath, Len(sPath))
    Call RegCloseKey(reghnd)
End Sub

Public Sub Delete(ByVal sExtension As String, ByVal sAppKeyName As String, Optional ByVal sVerb As String)
Attribute Delete.VB_Description = "Deletes a file association"
    If sVerb = "" Then
        If RegDeleteKey(&H80000000, sExtension) <> 0 Then Err.Raise 255, , "Key Doesn't Exist" Else RegDeleteKey &H80000000, sAppKeyName
    Else
        If RegDeleteKey(&H80000000, sAppKeyName & "\shell\" & sVerb) <> 0 Then Err.Raise 255, , "Key Doesn't Exist"
    End If
End Sub

Public Function GetAppKeyName(ByVal sExtension As String) As String
    Dim reghnd As Long
    Dim tempstr As String
    Dim strlen As Long
    tempstr = Space(255)
    strlen = 255
    Call RegOpenKeyEx(&H80000000, sExtension, 0&, &H20019, reghnd)
    Call RegQueryValueEx(reghnd, "", 0&, 1, ByVal tempstr, strlen)
    GetAppKeyName = Left$(tempstr, strlen - 1)
    Call RegCloseKey(reghnd)
End Function

Public Function IsAssoc(ByVal sAppKeyName As String, ByVal sVerb As String) As Boolean
    If RegOpenKeyEx(&H80000000, sAppKeyName & "\shell\" & sVerb & "\command", 0&, &H20019, reghnd) <> 0 Then
        IsAssoc = False
    Else
        IsAssoc = True
        Call RegCloseKey(reghnd)
    End If
End Function
